#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK78x78x78TN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=78, NB=78, KB=78, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=6, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (78*(lda));
   const double *stN = B + (78*(ldb));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 1
   const int incAm = ((((lda) << 1)+lda) - 78), incAn = -(78*(lda));
   #define incBk 1
   const int incBm = -78, incBn = (((ldb) << 2)+((ldb) << 1));
   #define incCm 3
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 78;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb);
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3, rC0_4, rC1_4, rC2_4, rC0_5, rC1_5, rC2_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC2_2 = pC2[2];
         rC2_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC1_3 = pC3[1];
         rC1_3 *= rA0;
         rC2_3 = pC3[2];
         rC2_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC1_4 = pC4[1];
         rC1_4 *= rA0;
         rC2_4 = pC4[2];
         rC2_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         rC1_5 = pC5[1];
         rC1_5 *= rA0;
         rC2_5 = pC5[2];
         rC2_5 *= rA0;
         for (k=78; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            rA2 = *pA2;
            rB1 = *pB1;
            rC0_0 += rA0 * rB0;
            rB2 = *pB2;
            rB3 = *pB3;
            rC1_0 += rA1 * rB0;
            rB4 = *pB4;
            rB5 = *pB5;
            rC2_0 += rA2 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
            pB5 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC1_5 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         rC2_4 *= rB0;
         rC2_5 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         pC4[2] = rC2_4;
         *pC5 = rC0_5;
         pC5[1] = rC1_5;
         pC5[2] = rC2_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
