#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x72x72TN1x6x72_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=72, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=1, nu=6, ku=72, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 6)+((Mb) << 3));
   const double *stN = B + 5184;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*6)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 72
   const int incAm = 0, incAn = -(((Mb) << 6)+((Mb) << 3));
   #define incBk 72
   const int incBm = -72, incBn = 432;
   const int incAk0 = ((incAk) / 72), incBk0 = ((incBk) / 72);
   #define incCm 2
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4, m5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         rC0_4 = *pC4;
         rC0_5 = *pC5;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[72];
         rB2 = pB0[144];
         rB3 = pB0[216];
         m0 = rA0 * rB0;
         rB4 = pB0[288];
         rB5 = pB0[360];
         m1 = rA0 * rB1;
         m2 = rA0 * rB2;
         m3 = rA0 * rB3;
         m4 = rA0 * rB4;
         m5 = rA0 * rB5;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB0[73];
         rB2 = pB0[145];
         rB3 = pB0[217];
         rB4 = pB0[289];
         rB5 = pB0[361];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB0;
         rC0_1 = m1;
         m1 = rA0 * rB1;
         rC0_2 = m2;
         m2 = rA0 * rB2;
         rC0_3 = m3;
         m3 = rA0 * rB3;
         rC0_4 = m4;
         m4 = rA0 * rB4;
         rC0_5 = m5;
         m5 = rA0 * rB5;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB0[74];
         rB2 = pB0[146];
         rB3 = pB0[218];
         rB4 = pB0[290];
         rB5 = pB0[362];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB0[75];
         rB2 = pB0[147];
         rB3 = pB0[219];
         rB4 = pB0[291];
         rB5 = pB0[363];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB0[76];
         rB2 = pB0[148];
         rB3 = pB0[220];
         rB4 = pB0[292];
         rB5 = pB0[364];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB0[77];
         rB2 = pB0[149];
         rB3 = pB0[221];
         rB4 = pB0[293];
         rB5 = pB0[365];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB0[78];
         rB2 = pB0[150];
         rB3 = pB0[222];
         rB4 = pB0[294];
         rB5 = pB0[366];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB0[79];
         rB2 = pB0[151];
         rB3 = pB0[223];
         rB4 = pB0[295];
         rB5 = pB0[367];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB0[80];
         rB2 = pB0[152];
         rB3 = pB0[224];
         rB4 = pB0[296];
         rB5 = pB0[368];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB0[81];
         rB2 = pB0[153];
         rB3 = pB0[225];
         rB4 = pB0[297];
         rB5 = pB0[369];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB0[82];
         rB2 = pB0[154];
         rB3 = pB0[226];
         rB4 = pB0[298];
         rB5 = pB0[370];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB0[83];
         rB2 = pB0[155];
         rB3 = pB0[227];
         rB4 = pB0[299];
         rB5 = pB0[371];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB0[84];
         rB2 = pB0[156];
         rB3 = pB0[228];
         rB4 = pB0[300];
         rB5 = pB0[372];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB0[85];
         rB2 = pB0[157];
         rB3 = pB0[229];
         rB4 = pB0[301];
         rB5 = pB0[373];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB0[86];
         rB2 = pB0[158];
         rB3 = pB0[230];
         rB4 = pB0[302];
         rB5 = pB0[374];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB0[87];
         rB2 = pB0[159];
         rB3 = pB0[231];
         rB4 = pB0[303];
         rB5 = pB0[375];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB0[88];
         rB2 = pB0[160];
         rB3 = pB0[232];
         rB4 = pB0[304];
         rB5 = pB0[376];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rB1 = pB0[89];
         rB2 = pB0[161];
         rB3 = pB0[233];
         rB4 = pB0[305];
         rB5 = pB0[377];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB0[90];
         rB2 = pB0[162];
         rB3 = pB0[234];
         rB4 = pB0[306];
         rB5 = pB0[378];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rB1 = pB0[91];
         rB2 = pB0[163];
         rB3 = pB0[235];
         rB4 = pB0[307];
         rB5 = pB0[379];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB0[92];
         rB2 = pB0[164];
         rB3 = pB0[236];
         rB4 = pB0[308];
         rB5 = pB0[380];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rB1 = pB0[93];
         rB2 = pB0[165];
         rB3 = pB0[237];
         rB4 = pB0[309];
         rB5 = pB0[381];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB0[94];
         rB2 = pB0[166];
         rB3 = pB0[238];
         rB4 = pB0[310];
         rB5 = pB0[382];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rB1 = pB0[95];
         rB2 = pB0[167];
         rB3 = pB0[239];
         rB4 = pB0[311];
         rB5 = pB0[383];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB0[96];
         rB2 = pB0[168];
         rB3 = pB0[240];
         rB4 = pB0[312];
         rB5 = pB0[384];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rB1 = pB0[97];
         rB2 = pB0[169];
         rB3 = pB0[241];
         rB4 = pB0[313];
         rB5 = pB0[385];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB0[98];
         rB2 = pB0[170];
         rB3 = pB0[242];
         rB4 = pB0[314];
         rB5 = pB0[386];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rB1 = pB0[99];
         rB2 = pB0[171];
         rB3 = pB0[243];
         rB4 = pB0[315];
         rB5 = pB0[387];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB0[100];
         rB2 = pB0[172];
         rB3 = pB0[244];
         rB4 = pB0[316];
         rB5 = pB0[388];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rB1 = pB0[101];
         rB2 = pB0[173];
         rB3 = pB0[245];
         rB4 = pB0[317];
         rB5 = pB0[389];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB0[102];
         rB2 = pB0[174];
         rB3 = pB0[246];
         rB4 = pB0[318];
         rB5 = pB0[390];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rB1 = pB0[103];
         rB2 = pB0[175];
         rB3 = pB0[247];
         rB4 = pB0[319];
         rB5 = pB0[391];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rB1 = pB0[104];
         rB2 = pB0[176];
         rB3 = pB0[248];
         rB4 = pB0[320];
         rB5 = pB0[392];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rB1 = pB0[105];
         rB2 = pB0[177];
         rB3 = pB0[249];
         rB4 = pB0[321];
         rB5 = pB0[393];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rB1 = pB0[106];
         rB2 = pB0[178];
         rB3 = pB0[250];
         rB4 = pB0[322];
         rB5 = pB0[394];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rB1 = pB0[107];
         rB2 = pB0[179];
         rB3 = pB0[251];
         rB4 = pB0[323];
         rB5 = pB0[395];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rB1 = pB0[108];
         rB2 = pB0[180];
         rB3 = pB0[252];
         rB4 = pB0[324];
         rB5 = pB0[396];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rB1 = pB0[109];
         rB2 = pB0[181];
         rB3 = pB0[253];
         rB4 = pB0[325];
         rB5 = pB0[397];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rB1 = pB0[110];
         rB2 = pB0[182];
         rB3 = pB0[254];
         rB4 = pB0[326];
         rB5 = pB0[398];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rB1 = pB0[111];
         rB2 = pB0[183];
         rB3 = pB0[255];
         rB4 = pB0[327];
         rB5 = pB0[399];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rB1 = pB0[112];
         rB2 = pB0[184];
         rB3 = pB0[256];
         rB4 = pB0[328];
         rB5 = pB0[400];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rB1 = pB0[113];
         rB2 = pB0[185];
         rB3 = pB0[257];
         rB4 = pB0[329];
         rB5 = pB0[401];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rB1 = pB0[114];
         rB2 = pB0[186];
         rB3 = pB0[258];
         rB4 = pB0[330];
         rB5 = pB0[402];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rB1 = pB0[115];
         rB2 = pB0[187];
         rB3 = pB0[259];
         rB4 = pB0[331];
         rB5 = pB0[403];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rB1 = pB0[116];
         rB2 = pB0[188];
         rB3 = pB0[260];
         rB4 = pB0[332];
         rB5 = pB0[404];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rB1 = pB0[117];
         rB2 = pB0[189];
         rB3 = pB0[261];
         rB4 = pB0[333];
         rB5 = pB0[405];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rB1 = pB0[118];
         rB2 = pB0[190];
         rB3 = pB0[262];
         rB4 = pB0[334];
         rB5 = pB0[406];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rB1 = pB0[119];
         rB2 = pB0[191];
         rB3 = pB0[263];
         rB4 = pB0[335];
         rB5 = pB0[407];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rB1 = pB0[120];
         rB2 = pB0[192];
         rB3 = pB0[264];
         rB4 = pB0[336];
         rB5 = pB0[408];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[49];
         rB0 = pB0[49];
         rB1 = pB0[121];
         rB2 = pB0[193];
         rB3 = pB0[265];
         rB4 = pB0[337];
         rB5 = pB0[409];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rB1 = pB0[122];
         rB2 = pB0[194];
         rB3 = pB0[266];
         rB4 = pB0[338];
         rB5 = pB0[410];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[51];
         rB0 = pB0[51];
         rB1 = pB0[123];
         rB2 = pB0[195];
         rB3 = pB0[267];
         rB4 = pB0[339];
         rB5 = pB0[411];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rB1 = pB0[124];
         rB2 = pB0[196];
         rB3 = pB0[268];
         rB4 = pB0[340];
         rB5 = pB0[412];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[53];
         rB0 = pB0[53];
         rB1 = pB0[125];
         rB2 = pB0[197];
         rB3 = pB0[269];
         rB4 = pB0[341];
         rB5 = pB0[413];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rB1 = pB0[126];
         rB2 = pB0[198];
         rB3 = pB0[270];
         rB4 = pB0[342];
         rB5 = pB0[414];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[55];
         rB0 = pB0[55];
         rB1 = pB0[127];
         rB2 = pB0[199];
         rB3 = pB0[271];
         rB4 = pB0[343];
         rB5 = pB0[415];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rB1 = pB0[128];
         rB2 = pB0[200];
         rB3 = pB0[272];
         rB4 = pB0[344];
         rB5 = pB0[416];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[57];
         rB0 = pB0[57];
         rB1 = pB0[129];
         rB2 = pB0[201];
         rB3 = pB0[273];
         rB4 = pB0[345];
         rB5 = pB0[417];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rB1 = pB0[130];
         rB2 = pB0[202];
         rB3 = pB0[274];
         rB4 = pB0[346];
         rB5 = pB0[418];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[59];
         rB0 = pB0[59];
         rB1 = pB0[131];
         rB2 = pB0[203];
         rB3 = pB0[275];
         rB4 = pB0[347];
         rB5 = pB0[419];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[60];
         rB0 = pB0[60];
         rB1 = pB0[132];
         rB2 = pB0[204];
         rB3 = pB0[276];
         rB4 = pB0[348];
         rB5 = pB0[420];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[61];
         rB0 = pB0[61];
         rB1 = pB0[133];
         rB2 = pB0[205];
         rB3 = pB0[277];
         rB4 = pB0[349];
         rB5 = pB0[421];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[62];
         rB0 = pB0[62];
         rB1 = pB0[134];
         rB2 = pB0[206];
         rB3 = pB0[278];
         rB4 = pB0[350];
         rB5 = pB0[422];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[63];
         rB0 = pB0[63];
         rB1 = pB0[135];
         rB2 = pB0[207];
         rB3 = pB0[279];
         rB4 = pB0[351];
         rB5 = pB0[423];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[64];
         rB0 = pB0[64];
         rB1 = pB0[136];
         rB2 = pB0[208];
         rB3 = pB0[280];
         rB4 = pB0[352];
         rB5 = pB0[424];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[65];
         rB0 = pB0[65];
         rB1 = pB0[137];
         rB2 = pB0[209];
         rB3 = pB0[281];
         rB4 = pB0[353];
         rB5 = pB0[425];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[66];
         rB0 = pB0[66];
         rB1 = pB0[138];
         rB2 = pB0[210];
         rB3 = pB0[282];
         rB4 = pB0[354];
         rB5 = pB0[426];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[67];
         rB0 = pB0[67];
         rB1 = pB0[139];
         rB2 = pB0[211];
         rB3 = pB0[283];
         rB4 = pB0[355];
         rB5 = pB0[427];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[68];
         rB0 = pB0[68];
         rB1 = pB0[140];
         rB2 = pB0[212];
         rB3 = pB0[284];
         rB4 = pB0[356];
         rB5 = pB0[428];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[69];
         rB0 = pB0[69];
         rB1 = pB0[141];
         rB2 = pB0[213];
         rB3 = pB0[285];
         rB4 = pB0[357];
         rB5 = pB0[429];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[70];
         rB0 = pB0[70];
         rB1 = pB0[142];
         rB2 = pB0[214];
         rB3 = pB0[286];
         rB4 = pB0[358];
         rB5 = pB0[430];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rA0 = pA0[71];
         rB0 = pB0[71];
         rB1 = pB0[143];
         rB2 = pB0[215];
         rB3 = pB0[287];
         rB4 = pB0[359];
         rB5 = pB0[431];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_1 += m1;
         m1 = rA0 * rB1;
         rC0_2 += m2;
         m2 = rA0 * rB2;
         rC0_3 += m3;
         m3 = rA0 * rB3;
         rC0_4 += m4;
         m4 = rA0 * rB4;
         rC0_5 += m5;
         m5 = rA0 * rB5;
         rC0_0 += m0;
         rC0_1 += m1;
         rC0_2 += m2;
         rC0_3 += m3;
         rC0_4 += m4;
         rC0_5 += m5;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x72x72TN72x72x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=72, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=3, nu=6, ku=72, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/3)*3;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 6)+((Mb) << 3));
   const double *stN = B + 5184;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*6)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 72
   const int incAm = 144, incAn = -(((Mb) << 6)+((Mb) << 3));
   #define incBk 72
   const int incBm = -72, incBn = 432;
   const int incAk0 = ((incAk) / 72), incBk0 = ((incBk) / 72);
   #define incCm 6
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double m0, m1, m2, m3, m4;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3, rC0_4, rC1_4, rC2_4, rC0_5, rC1_5, rC2_5;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            ATL_pfl1R(pfA+ATL_L1LS);
            pfA += incPFA;
/*
 *          Feeble prefetch of C
 */
            rC0_0 = *pC0;
            rC0_1 = *pC1;
            rC0_2 = *pC2;
            rC0_3 = *pC3;
            rC0_4 = *pC4;
            rC0_5 = *pC5;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
            ATL_pfl1W(pC3);
            ATL_pfl1W(pC4);
            ATL_pfl1W(pC5);
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[72];
            rA2 = pA0[144];
            rB1 = pB0[72];
            m0 = rA0 * rB0;
            rB2 = pB0[144];
            rB3 = pB0[216];
            m1 = rA1 * rB0;
            rB4 = pB0[288];
            rB5 = pB0[360];
            m2 = rA2 * rB0;
            m3 = rA0 * rB1;
            m4 = rA1 * rB1;

/*
 *          Completely unrolled K-loop
 */
            rC0_0 = m0;
            m0 = rA2 * rB1;
            rC1_0 = m1;
            m1 = rA0 * rB2;
            rC2_0 = m2;
            m2 = rA1 * rB2;
            rC0_1 = m3;
            m3 = rA2 * rB2;
            rC1_1 = m4;
            m4 = rA0 * rB3;
            rC2_1 = m0;
            m0 = rA1 * rB3;
            rC0_2 = m1;
            m1 = rA2 * rB3;
            rC1_2 = m2;
            m2 = rA0 * rB4;
            rC2_2 = m3;
            m3 = rA1 * rB4;
            rC0_3 = m4;
            m4 = rA2 * rB4;
            rC1_3 = m0;
            m0 = rA0 * rB5;
            rC2_3 = m1;
            m1 = rA1 * rB5;
            rC0_4 = m2;
            m2 = rA2 * rB5;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[73];
            rA2 = pA0[145];
            rB1 = pB0[73];
            rB2 = pB0[145];
            rB3 = pB0[217];
            rC1_4 = m3;
            m3 = rA0 * rB0;
            rB4 = pB0[289];
            rB5 = pB0[361];
            rC2_4 = m4;
            m4 = rA1 * rB0;
            rC0_5 = m0;
            m0 = rA2 * rB0;
            rC1_5 = m1;
            m1 = rA0 * rB1;
            rC2_5 = m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[74];
            rA2 = pA0[146];
            rB1 = pB0[74];
            rB2 = pB0[146];
            rB3 = pB0[218];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[290];
            rB5 = pB0[362];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[75];
            rA2 = pA0[147];
            rB1 = pB0[75];
            rB2 = pB0[147];
            rB3 = pB0[219];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[291];
            rB5 = pB0[363];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[76];
            rA2 = pA0[148];
            rB1 = pB0[76];
            rB2 = pB0[148];
            rB3 = pB0[220];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[292];
            rB5 = pB0[364];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[77];
            rA2 = pA0[149];
            rB1 = pB0[77];
            rB2 = pB0[149];
            rB3 = pB0[221];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[293];
            rB5 = pB0[365];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[78];
            rA2 = pA0[150];
            rB1 = pB0[78];
            rB2 = pB0[150];
            rB3 = pB0[222];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[294];
            rB5 = pB0[366];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[79];
            rA2 = pA0[151];
            rB1 = pB0[79];
            rB2 = pB0[151];
            rB3 = pB0[223];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[295];
            rB5 = pB0[367];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[80];
            rA2 = pA0[152];
            rB1 = pB0[80];
            rB2 = pB0[152];
            rB3 = pB0[224];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[296];
            rB5 = pB0[368];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[81];
            rA2 = pA0[153];
            rB1 = pB0[81];
            rB2 = pB0[153];
            rB3 = pB0[225];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[297];
            rB5 = pB0[369];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[82];
            rA2 = pA0[154];
            rB1 = pB0[82];
            rB2 = pB0[154];
            rB3 = pB0[226];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[298];
            rB5 = pB0[370];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[83];
            rA2 = pA0[155];
            rB1 = pB0[83];
            rB2 = pB0[155];
            rB3 = pB0[227];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[299];
            rB5 = pB0[371];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[84];
            rA2 = pA0[156];
            rB1 = pB0[84];
            rB2 = pB0[156];
            rB3 = pB0[228];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[300];
            rB5 = pB0[372];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[85];
            rA2 = pA0[157];
            rB1 = pB0[85];
            rB2 = pB0[157];
            rB3 = pB0[229];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[301];
            rB5 = pB0[373];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[86];
            rA2 = pA0[158];
            rB1 = pB0[86];
            rB2 = pB0[158];
            rB3 = pB0[230];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[302];
            rB5 = pB0[374];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[87];
            rA2 = pA0[159];
            rB1 = pB0[87];
            rB2 = pB0[159];
            rB3 = pB0[231];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[303];
            rB5 = pB0[375];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rA1 = pA0[88];
            rA2 = pA0[160];
            rB1 = pB0[88];
            rB2 = pB0[160];
            rB3 = pB0[232];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[304];
            rB5 = pB0[376];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rA1 = pA0[89];
            rA2 = pA0[161];
            rB1 = pB0[89];
            rB2 = pB0[161];
            rB3 = pB0[233];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[305];
            rB5 = pB0[377];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rA1 = pA0[90];
            rA2 = pA0[162];
            rB1 = pB0[90];
            rB2 = pB0[162];
            rB3 = pB0[234];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[306];
            rB5 = pB0[378];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rA1 = pA0[91];
            rA2 = pA0[163];
            rB1 = pB0[91];
            rB2 = pB0[163];
            rB3 = pB0[235];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[307];
            rB5 = pB0[379];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rA1 = pA0[92];
            rA2 = pA0[164];
            rB1 = pB0[92];
            rB2 = pB0[164];
            rB3 = pB0[236];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[308];
            rB5 = pB0[380];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rA1 = pA0[93];
            rA2 = pA0[165];
            rB1 = pB0[93];
            rB2 = pB0[165];
            rB3 = pB0[237];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[309];
            rB5 = pB0[381];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rA1 = pA0[94];
            rA2 = pA0[166];
            rB1 = pB0[94];
            rB2 = pB0[166];
            rB3 = pB0[238];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[310];
            rB5 = pB0[382];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rA1 = pA0[95];
            rA2 = pA0[167];
            rB1 = pB0[95];
            rB2 = pB0[167];
            rB3 = pB0[239];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[311];
            rB5 = pB0[383];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[24];
            rB0 = pB0[24];
            rA1 = pA0[96];
            rA2 = pA0[168];
            rB1 = pB0[96];
            rB2 = pB0[168];
            rB3 = pB0[240];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[312];
            rB5 = pB0[384];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[25];
            rB0 = pB0[25];
            rA1 = pA0[97];
            rA2 = pA0[169];
            rB1 = pB0[97];
            rB2 = pB0[169];
            rB3 = pB0[241];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[313];
            rB5 = pB0[385];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[26];
            rB0 = pB0[26];
            rA1 = pA0[98];
            rA2 = pA0[170];
            rB1 = pB0[98];
            rB2 = pB0[170];
            rB3 = pB0[242];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[314];
            rB5 = pB0[386];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[27];
            rB0 = pB0[27];
            rA1 = pA0[99];
            rA2 = pA0[171];
            rB1 = pB0[99];
            rB2 = pB0[171];
            rB3 = pB0[243];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[315];
            rB5 = pB0[387];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[28];
            rB0 = pB0[28];
            rA1 = pA0[100];
            rA2 = pA0[172];
            rB1 = pB0[100];
            rB2 = pB0[172];
            rB3 = pB0[244];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[316];
            rB5 = pB0[388];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[29];
            rB0 = pB0[29];
            rA1 = pA0[101];
            rA2 = pA0[173];
            rB1 = pB0[101];
            rB2 = pB0[173];
            rB3 = pB0[245];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[317];
            rB5 = pB0[389];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[30];
            rB0 = pB0[30];
            rA1 = pA0[102];
            rA2 = pA0[174];
            rB1 = pB0[102];
            rB2 = pB0[174];
            rB3 = pB0[246];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[318];
            rB5 = pB0[390];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[31];
            rB0 = pB0[31];
            rA1 = pA0[103];
            rA2 = pA0[175];
            rB1 = pB0[103];
            rB2 = pB0[175];
            rB3 = pB0[247];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[319];
            rB5 = pB0[391];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[32];
            rB0 = pB0[32];
            rA1 = pA0[104];
            rA2 = pA0[176];
            rB1 = pB0[104];
            rB2 = pB0[176];
            rB3 = pB0[248];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[320];
            rB5 = pB0[392];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[33];
            rB0 = pB0[33];
            rA1 = pA0[105];
            rA2 = pA0[177];
            rB1 = pB0[105];
            rB2 = pB0[177];
            rB3 = pB0[249];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[321];
            rB5 = pB0[393];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[34];
            rB0 = pB0[34];
            rA1 = pA0[106];
            rA2 = pA0[178];
            rB1 = pB0[106];
            rB2 = pB0[178];
            rB3 = pB0[250];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[322];
            rB5 = pB0[394];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[35];
            rB0 = pB0[35];
            rA1 = pA0[107];
            rA2 = pA0[179];
            rB1 = pB0[107];
            rB2 = pB0[179];
            rB3 = pB0[251];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[323];
            rB5 = pB0[395];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[36];
            rB0 = pB0[36];
            rA1 = pA0[108];
            rA2 = pA0[180];
            rB1 = pB0[108];
            rB2 = pB0[180];
            rB3 = pB0[252];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[324];
            rB5 = pB0[396];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[37];
            rB0 = pB0[37];
            rA1 = pA0[109];
            rA2 = pA0[181];
            rB1 = pB0[109];
            rB2 = pB0[181];
            rB3 = pB0[253];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[325];
            rB5 = pB0[397];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[38];
            rB0 = pB0[38];
            rA1 = pA0[110];
            rA2 = pA0[182];
            rB1 = pB0[110];
            rB2 = pB0[182];
            rB3 = pB0[254];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[326];
            rB5 = pB0[398];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[39];
            rB0 = pB0[39];
            rA1 = pA0[111];
            rA2 = pA0[183];
            rB1 = pB0[111];
            rB2 = pB0[183];
            rB3 = pB0[255];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[327];
            rB5 = pB0[399];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[40];
            rB0 = pB0[40];
            rA1 = pA0[112];
            rA2 = pA0[184];
            rB1 = pB0[112];
            rB2 = pB0[184];
            rB3 = pB0[256];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[328];
            rB5 = pB0[400];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[41];
            rB0 = pB0[41];
            rA1 = pA0[113];
            rA2 = pA0[185];
            rB1 = pB0[113];
            rB2 = pB0[185];
            rB3 = pB0[257];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[329];
            rB5 = pB0[401];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[42];
            rB0 = pB0[42];
            rA1 = pA0[114];
            rA2 = pA0[186];
            rB1 = pB0[114];
            rB2 = pB0[186];
            rB3 = pB0[258];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[330];
            rB5 = pB0[402];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[43];
            rB0 = pB0[43];
            rA1 = pA0[115];
            rA2 = pA0[187];
            rB1 = pB0[115];
            rB2 = pB0[187];
            rB3 = pB0[259];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[331];
            rB5 = pB0[403];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[44];
            rB0 = pB0[44];
            rA1 = pA0[116];
            rA2 = pA0[188];
            rB1 = pB0[116];
            rB2 = pB0[188];
            rB3 = pB0[260];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[332];
            rB5 = pB0[404];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[45];
            rB0 = pB0[45];
            rA1 = pA0[117];
            rA2 = pA0[189];
            rB1 = pB0[117];
            rB2 = pB0[189];
            rB3 = pB0[261];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[333];
            rB5 = pB0[405];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[46];
            rB0 = pB0[46];
            rA1 = pA0[118];
            rA2 = pA0[190];
            rB1 = pB0[118];
            rB2 = pB0[190];
            rB3 = pB0[262];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[334];
            rB5 = pB0[406];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[47];
            rB0 = pB0[47];
            rA1 = pA0[119];
            rA2 = pA0[191];
            rB1 = pB0[119];
            rB2 = pB0[191];
            rB3 = pB0[263];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[335];
            rB5 = pB0[407];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[48];
            rB0 = pB0[48];
            rA1 = pA0[120];
            rA2 = pA0[192];
            rB1 = pB0[120];
            rB2 = pB0[192];
            rB3 = pB0[264];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[336];
            rB5 = pB0[408];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[49];
            rB0 = pB0[49];
            rA1 = pA0[121];
            rA2 = pA0[193];
            rB1 = pB0[121];
            rB2 = pB0[193];
            rB3 = pB0[265];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[337];
            rB5 = pB0[409];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[50];
            rB0 = pB0[50];
            rA1 = pA0[122];
            rA2 = pA0[194];
            rB1 = pB0[122];
            rB2 = pB0[194];
            rB3 = pB0[266];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[338];
            rB5 = pB0[410];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[51];
            rB0 = pB0[51];
            rA1 = pA0[123];
            rA2 = pA0[195];
            rB1 = pB0[123];
            rB2 = pB0[195];
            rB3 = pB0[267];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[339];
            rB5 = pB0[411];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[52];
            rB0 = pB0[52];
            rA1 = pA0[124];
            rA2 = pA0[196];
            rB1 = pB0[124];
            rB2 = pB0[196];
            rB3 = pB0[268];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[340];
            rB5 = pB0[412];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[53];
            rB0 = pB0[53];
            rA1 = pA0[125];
            rA2 = pA0[197];
            rB1 = pB0[125];
            rB2 = pB0[197];
            rB3 = pB0[269];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[341];
            rB5 = pB0[413];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[54];
            rB0 = pB0[54];
            rA1 = pA0[126];
            rA2 = pA0[198];
            rB1 = pB0[126];
            rB2 = pB0[198];
            rB3 = pB0[270];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[342];
            rB5 = pB0[414];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[55];
            rB0 = pB0[55];
            rA1 = pA0[127];
            rA2 = pA0[199];
            rB1 = pB0[127];
            rB2 = pB0[199];
            rB3 = pB0[271];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[343];
            rB5 = pB0[415];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[56];
            rB0 = pB0[56];
            rA1 = pA0[128];
            rA2 = pA0[200];
            rB1 = pB0[128];
            rB2 = pB0[200];
            rB3 = pB0[272];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[344];
            rB5 = pB0[416];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[57];
            rB0 = pB0[57];
            rA1 = pA0[129];
            rA2 = pA0[201];
            rB1 = pB0[129];
            rB2 = pB0[201];
            rB3 = pB0[273];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[345];
            rB5 = pB0[417];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[58];
            rB0 = pB0[58];
            rA1 = pA0[130];
            rA2 = pA0[202];
            rB1 = pB0[130];
            rB2 = pB0[202];
            rB3 = pB0[274];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[346];
            rB5 = pB0[418];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[59];
            rB0 = pB0[59];
            rA1 = pA0[131];
            rA2 = pA0[203];
            rB1 = pB0[131];
            rB2 = pB0[203];
            rB3 = pB0[275];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[347];
            rB5 = pB0[419];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[60];
            rB0 = pB0[60];
            rA1 = pA0[132];
            rA2 = pA0[204];
            rB1 = pB0[132];
            rB2 = pB0[204];
            rB3 = pB0[276];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[348];
            rB5 = pB0[420];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[61];
            rB0 = pB0[61];
            rA1 = pA0[133];
            rA2 = pA0[205];
            rB1 = pB0[133];
            rB2 = pB0[205];
            rB3 = pB0[277];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[349];
            rB5 = pB0[421];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[62];
            rB0 = pB0[62];
            rA1 = pA0[134];
            rA2 = pA0[206];
            rB1 = pB0[134];
            rB2 = pB0[206];
            rB3 = pB0[278];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[350];
            rB5 = pB0[422];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[63];
            rB0 = pB0[63];
            rA1 = pA0[135];
            rA2 = pA0[207];
            rB1 = pB0[135];
            rB2 = pB0[207];
            rB3 = pB0[279];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[351];
            rB5 = pB0[423];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[64];
            rB0 = pB0[64];
            rA1 = pA0[136];
            rA2 = pA0[208];
            rB1 = pB0[136];
            rB2 = pB0[208];
            rB3 = pB0[280];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[352];
            rB5 = pB0[424];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[65];
            rB0 = pB0[65];
            rA1 = pA0[137];
            rA2 = pA0[209];
            rB1 = pB0[137];
            rB2 = pB0[209];
            rB3 = pB0[281];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[353];
            rB5 = pB0[425];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[66];
            rB0 = pB0[66];
            rA1 = pA0[138];
            rA2 = pA0[210];
            rB1 = pB0[138];
            rB2 = pB0[210];
            rB3 = pB0[282];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[354];
            rB5 = pB0[426];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rA0 = pA0[67];
            rB0 = pB0[67];
            rA1 = pA0[139];
            rA2 = pA0[211];
            rB1 = pB0[139];
            rB2 = pB0[211];
            rB3 = pB0[283];
            rC1_4 += m1;
            m1 = rA0 * rB0;
            rB4 = pB0[355];
            rB5 = pB0[427];
            rC2_4 += m2;
            m2 = rA1 * rB0;
            rC0_5 += m3;
            m3 = rA2 * rB0;
            rC1_5 += m4;
            m4 = rA0 * rB1;
            rC2_5 += m0;
            m0 = rA1 * rB1;
            rC0_0 += m1;
            m1 = rA2 * rB1;
            rC1_0 += m2;
            m2 = rA0 * rB2;
            rC2_0 += m3;
            m3 = rA1 * rB2;
            rC0_1 += m4;
            m4 = rA2 * rB2;
            rC1_1 += m0;
            m0 = rA0 * rB3;
            rC2_1 += m1;
            m1 = rA1 * rB3;
            rC0_2 += m2;
            m2 = rA2 * rB3;
            rC1_2 += m3;
            m3 = rA0 * rB4;
            rC2_2 += m4;
            m4 = rA1 * rB4;
            rC0_3 += m0;
            m0 = rA2 * rB4;
            rC1_3 += m1;
            m1 = rA0 * rB5;
            rC2_3 += m2;
            m2 = rA1 * rB5;
            rC0_4 += m3;
            m3 = rA2 * rB5;
            rA0 = pA0[68];
            rB0 = pB0[68];
            rA1 = pA0[140];
            rA2 = pA0[212];
            rB1 = pB0[140];
            rB2 = pB0[212];
            rB3 = pB0[284];
            rC1_4 += m4;
            m4 = rA0 * rB0;
            rB4 = pB0[356];
            rB5 = pB0[428];
            rC2_4 += m0;
            m0 = rA1 * rB0;
            rC0_5 += m1;
            m1 = rA2 * rB0;
            rC1_5 += m2;
            m2 = rA0 * rB1;
            rC2_5 += m3;
            m3 = rA1 * rB1;
            rC0_0 += m4;
            m4 = rA2 * rB1;
            rC1_0 += m0;
            m0 = rA0 * rB2;
            rC2_0 += m1;
            m1 = rA1 * rB2;
            rC0_1 += m2;
            m2 = rA2 * rB2;
            rC1_1 += m3;
            m3 = rA0 * rB3;
            rC2_1 += m4;
            m4 = rA1 * rB3;
            rC0_2 += m0;
            m0 = rA2 * rB3;
            rC1_2 += m1;
            m1 = rA0 * rB4;
            rC2_2 += m2;
            m2 = rA1 * rB4;
            rC0_3 += m3;
            m3 = rA2 * rB4;
            rC1_3 += m4;
            m4 = rA0 * rB5;
            rC2_3 += m0;
            m0 = rA1 * rB5;
            rC0_4 += m1;
            m1 = rA2 * rB5;
            rA0 = pA0[69];
            rB0 = pB0[69];
            rA1 = pA0[141];
            rA2 = pA0[213];
            rB1 = pB0[141];
            rB2 = pB0[213];
            rB3 = pB0[285];
            rC1_4 += m2;
            m2 = rA0 * rB0;
            rB4 = pB0[357];
            rB5 = pB0[429];
            rC2_4 += m3;
            m3 = rA1 * rB0;
            rC0_5 += m4;
            m4 = rA2 * rB0;
            rC1_5 += m0;
            m0 = rA0 * rB1;
            rC2_5 += m1;
            m1 = rA1 * rB1;
            rC0_0 += m2;
            m2 = rA2 * rB1;
            rC1_0 += m3;
            m3 = rA0 * rB2;
            rC2_0 += m4;
            m4 = rA1 * rB2;
            rC0_1 += m0;
            m0 = rA2 * rB2;
            rC1_1 += m1;
            m1 = rA0 * rB3;
            rC2_1 += m2;
            m2 = rA1 * rB3;
            rC0_2 += m3;
            m3 = rA2 * rB3;
            rC1_2 += m4;
            m4 = rA0 * rB4;
            rC2_2 += m0;
            m0 = rA1 * rB4;
            rC0_3 += m1;
            m1 = rA2 * rB4;
            rC1_3 += m2;
            m2 = rA0 * rB5;
            rC2_3 += m3;
            m3 = rA1 * rB5;
            rC0_4 += m4;
            m4 = rA2 * rB5;
            rA0 = pA0[70];
            rB0 = pB0[70];
            rA1 = pA0[142];
            rA2 = pA0[214];
            rB1 = pB0[142];
            rB2 = pB0[214];
            rB3 = pB0[286];
            rC1_4 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[358];
            rB5 = pB0[430];
            rC2_4 += m1;
            m1 = rA1 * rB0;
            rC0_5 += m2;
            m2 = rA2 * rB0;
            rC1_5 += m3;
            m3 = rA0 * rB1;
            rC2_5 += m4;
            m4 = rA1 * rB1;
            rC0_0 += m0;
            m0 = rA2 * rB1;
            rC1_0 += m1;
            m1 = rA0 * rB2;
            rC2_0 += m2;
            m2 = rA1 * rB2;
            rC0_1 += m3;
            m3 = rA2 * rB2;
            rC1_1 += m4;
            m4 = rA0 * rB3;
            rC2_1 += m0;
            m0 = rA1 * rB3;
            rC0_2 += m1;
            m1 = rA2 * rB3;
            rC1_2 += m2;
            m2 = rA0 * rB4;
            rC2_2 += m3;
            m3 = rA1 * rB4;
            rC0_3 += m4;
            m4 = rA2 * rB4;
            rC1_3 += m0;
            m0 = rA0 * rB5;
            rC2_3 += m1;
            m1 = rA1 * rB5;
            rC0_4 += m2;
            m2 = rA2 * rB5;
            rA0 = pA0[71];
            rB0 = pB0[71];
            rA1 = pA0[143];
            rA2 = pA0[215];
            rB1 = pB0[143];
            rB2 = pB0[215];
            rB3 = pB0[287];
            rC1_4 += m3;
            m3 = rA0 * rB0;
            rB4 = pB0[359];
            rB5 = pB0[431];
            rC2_4 += m4;
            m4 = rA1 * rB0;
            rC0_5 += m0;
            m0 = rA2 * rB0;
            rC1_5 += m1;
            m1 = rA0 * rB1;
            rC2_5 += m2;
            m2 = rA1 * rB1;
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m3;
            m3 = rA2 * rB1;
            rC1_0 += m4;
            m4 = rA0 * rB2;
            rC2_0 += m0;
            m0 = rA1 * rB2;
            rC0_1 += m1;
            m1 = rA2 * rB2;
            rC1_1 += m2;
            m2 = rA0 * rB3;
            rC2_1 += m3;
            m3 = rA1 * rB3;
            rC0_2 += m4;
            m4 = rA2 * rB3;
            rC1_2 += m0;
            m0 = rA0 * rB4;
            rC2_2 += m1;
            m1 = rA1 * rB4;
            rC0_3 += m2;
            m2 = rA2 * rB4;
            rC1_3 += m3;
            m3 = rA0 * rB5;
            rC2_3 += m4;
            m4 = rA1 * rB5;
            rC0_4 += m0;
            m0 = rA2 * rB5;
            rC1_4 += m1;
            rC2_4 += m2;
            rC0_5 += m3;
            rC1_5 += m4;
            rC2_5 += m0;
            pA0 += incAk;
            pB0 += incBk;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            pC3[4] = rC2_3;
            *pC4 = rC0_4;
            pC4[2] = rC1_4;
            pC4[4] = rC2_4;
            *pC5 = rC0_5;
            pC5[2] = rC1_5;
            pC5[4] = rC2_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x72x72TN1x6x72_a1_b0(k, 72, 72, alpha, ca + (((Mb) << 6)+((Mb) << 3)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANM
#define ATL_zpMBmm_b0 ATL_zgpMBmm_b0
#endif

void ATL_zJIK0x72x72TN72x72x0_a1_b0(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x72x72TN72x72x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x72x72TN72x72x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpMBmm_b0(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK0x72x72TN72x72x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK0x72x72TN72x72x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK0x72x72TN72x72x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK0x72x72TN72x72x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
